/* stmt.c
	P. Chongstitvatana
			25 Aug 97
   add after 		22 Aug 98

	3 Apr 2001  start project RZ
	automatic generate	26 Apr 2001
	add patchif()  21 Dec 2001
	integrate 2 passes into parse.c
	incorporate dcl.c into stmt.c  and change to one pass
	3 Jan 2002
*/

#include "compile.h"

#define		PRIVATE		static

extern int lv;		/* symtab.c */
extern FILE *FO;

int DS = 1;	/* index to data segment */

void expect( int tktype, char *mess )
{
  if( tok != tktype ) seterror(mess);
}

void seterror( char *mess )
{
  printf("line %d near '%s' : %s\n",line,tokstring,mess);
//  dumpSym2();
  exit(-1);
}

PRIVATE int formalParam()
{
  int found, pv = 0;
  while( tok == tkIDENTIFIER ) {
	installLocal(tokstring,&found);
	if(found) seterror("duplicate formal parameters");
    pv++;
	lex();
	if( tok == tkCOMMA ) lex();
  }
  return pv;
}

PRIVATE void chktype(int type1, int type2) {
  if( type1 != type2 ) seterror("identifier type mismatch");
}

PRIVATE int installFunc(char *name, int pv){
	int a, found, type, ref, arg;
	a = installGlobal(name,tyFUNCTION,0,pv,&found);
	if( found )	{
		getAt(a,&type,&ref,&arg);
		chktype(type,tyFUNCTION);
		if( arg != pv ) seterror("incorrect number of arguments");
	}
	return a;
}

int setFunc(char *name) {	/* set ref and gen icFunc,pv,0 */
	int a,pv;
	pv = formalParam();
	a = installFunc(name,pv);
	setRef(a,CP);
	out3(icFunc,pv,0);
	return pv;
}

/*  install global name  */
int putSym(char *name, int type, int ref, int arg){
	int a, found;
	a = installGlobal(name,type,ref,arg,&found);
	if(found) seterror("redefine global name");
	return a;
}

/* find ref of vector, if not found, error */
int getVec(char *name){
	int a, found, type, ref, arg;
	a = installGlobal(name,0,0,0,&found);
	if( !found ) seterror("undefine array");
	else {
		getAt(a,&type,&ref,&arg);
		chktype(type,tyVECTOR);
	}
	return ref;
}

extern int expr();

/* find index of func, process actual parameters */
int doFunc(char *name){
	char name2[NAMELEN];
	int a, pv = 0;
	strcpy(name2,name);			// save name
	while( tok != tkRPAREN && tok != tkEOF ) {
		expr();
		pv++;
		if( tok == tkCOMMA) lex();
	}
	a = installFunc(name2,pv);
	return a;
}

void clean() {
  int c;
  c = CS[CP - 1];
  if( c != icRet0 && c != icRet1 )
    out(icRet0);
  lv = 0;	// clear local symbol
}

void printstr() {
  char *s;
  s = tokstring;
  while( *s != '\0' ) {
    if( *s == '\\' && *(s+1) == 'n' ) {
      out2(icLit,13); out(icPrintch);
      out2(icLit,10); out(icPrintch);
      s += 2;
    } else {
      out2(icLit,*s); out(icPrintch);
      s++;
    }
  }
}

void doLval( char *name ){
  int a,type,ref,arg;
  a = install(name);
  getAt(a,&type,&ref,&arg);
  switch( type ) {
  case tySCALAR : out2(icLvalg,ref); break;
  case tyLOCAL : out2(icLval,ref); break;
  default : seterror("identifier type mismatch");
  }
}

void doRval( char *name ){
  int a,type,ref,arg;
  a = install(name);
  getAt(a,&type,&ref,&arg);
  switch( type ) {
  case tySCALAR : out2(icRvalg,ref); break;
  case tyLOCAL : out2(icRval,ref); break;
  default : seterror("identifier type mismatch");
  }
}

void commit( int status ) {
  if ( status == 0 ) seterror("syntax");
}

/* fix ifelse stmt 21 Dec 2001 */
void patchIf( int a, int b, int here ){
	if( b == here )
		patch(a,here);   /* no else stmt */
	else {
		patch(a,b+3);    /* jump to else stmt */
		patch(b+1,here); /* jump out */
	}
}
